<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>ScalarFieldEmbedding - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="ScalarFieldEmbedding.html">ScalarFieldEmbedding</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#getScalarField">getScalarField</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#getDistances">getDistances</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#.getEmbedding">getEmbedding</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#.getAtlas">getAtlas</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#.asJSON">asJSON</a></li><li data-type='method' style='display: none;'><a href="ScalarFieldEmbedding.html#.asImage">asImage</a></li></ul></li><li><a href="opencv.html">opencv</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="opencv.html#.randomOrthonormal">randomOrthonormal</a></li><li data-type='method' style='display: none;'><a href="opencv.html#.orthonormalizes">orthonormalizes</a></li><li data-type='method' style='display: none;'><a href="opencv.html#.rank">rank</a></li><li data-type='method' style='display: none;'><a href="opencv.html#.mat2txt">mat2txt</a></li><li data-type='method' style='display: none;'><a href="opencv.html#.putText">putText</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">ScalarFieldEmbedding</h1>
    

    




<section>

<header>
    
        <h2>
        
            ScalarFieldEmbedding
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="ScalarFieldEmbedding"><span class="type-signature"></span>new ScalarFieldEmbedding<span class="signature">(parameters, scalarfield|distances<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a scalar-field numerical embedding (preliminary implementation).</p>
<ul>
<li>This implements the <a href="https://www.overleaf.com/read/prntythcxgnp#42f62c">Metrizable symbolic data structure embedding</a> draft.</li>
<li>A <a href="https://line.gitlabpages.inria.fr/aide-group/symboling/embeddingdemo/type-field-embedding.html">numeric demo</a> is available.</li>
</ul>
<p><a name="parameters"></a></p>
<h2>ScalarFieldEmbedding parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>NaN: ...</code> If true take also into account scalar-field points with undefined values. Default is false.</li>
<li><code>verbose: ...</code> If true print the interpolation, extrapolation and barycenter intermediate values. Default is false.</li>
</ul>
<h3>ScalarField parameter</h3>
<ul>
<li>The underlying scalar-field parameters if the scalar-field is ommitied but defined here by its parameters.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The scalar-field embedding parameters.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>scalarfield|distances</code></td>
            

            <td class="type">
            
                
<span class="param-type">ScalarField</span>
|

<span class="param-type">Mat</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>The scalar-field parameters or directly the distance matrix where the lower-triangle part <code>i &lt; j, D[i, j]</code> is defined.</p></td>
        </tr>

    
    </tbody>
</table>














<h5 class="h5-throws">Throws:</h5>

        

    <div class="param-desc usertext">
    
        <p>illegal-argument If distance triangle inequality is not verified.</p>
    
    </div>


    





        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getParameters"><span class="type-signature"></span>getParameters<span class="signature">()</span><span class="type-signature"> &rarr; {JSON}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the trajectory parameters.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The trajectory parameters.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="setParameters"><span class="type-signature"></span>setParameters<span class="signature">(parameters)</span><span class="type-signature"> &rarr; {ScalarField}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Modifies some ScalarField parameters.</p>
<ul>
<li>All parameters but the <code>type</code> can be modified.</li>
<li>The ScalarField points are preserved when changing the parameters, thus using the <code>points</code> field simply adds the points.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>The Trajectory parameters.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value allowing to chain methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">ScalarField</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getScalarField"><span class="type-signature"></span>getScalarField<span class="signature">()</span><span class="type-signature"> &rarr; {ScalarField}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the underlying scalar-field.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The scalar-field read-only pointer, if defined NULL otherwise.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">ScalarField</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getDistances"><span class="type-signature"></span>getDistances<span class="signature">()</span><span class="type-signature"> &rarr; {Mat}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the underlying distances-field.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The cv::Mat read-only distances matrix.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Mat</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getEmbedding"><span class="type-signature type-signature-static">(static) </span>getEmbedding<span class="signature">(dimension)</span><span class="type-signature"> &rarr; {Embedding}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Calculates and returns an approximate affine embedding.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>dimension</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>Affine embedding dimension. If <code>0</code>, return the minimal dimension of the best approximation.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The embedding as a C++ data struture.</p>
<pre class="prettyprint source"><code>struct Embedding {
  // Exponent of the phi(d) : d -> d^(1/n) function, so that phi(d_ij) = ||x_i-x_j||.
  unsigned int phi_n;
  // Circumscribing hypersphere radius and vector magnitudes
  double d_c;
  // The embedding coordinates of the obtained dimension = X.rows for count = X.cols vectors.
  cv::Mat X;
  // The embedding labels
  std::vector &lt;std::string> labels;
  // The embedding chosen dimension and obtained rank
  unsigned int dimension, rank;
};
</code></pre>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Embedding</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getAtlas"><span class="type-signature type-signature-static">(static) </span>getAtlas<span class="signature">()</span><span class="type-signature"> &rarr; {Atlas}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Calculates and returns the embedding atlas.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The embedding atlas as a C++ data struture.</p>
<pre class="prettyprint source"><code>struct Atlas {
  // The embedding labels
  std::vector &lt;std::string> labels;
  // The index &lt;-> value correspondences, if a scalarfield is defined
  std::vector &lt; wjson::Value > index2value;
  std::map &lt; wjson::Value, unsigned int > value2index;
  // Defines a chart
  struct Chart {
	   // The chart value indexes, as given by index2value
	   // - The chart size is indexes.size()
	   // - The chart value index is indexes.at(0)
    std::vector &lt; unsigned int > indexes;
    // The chart value increasing distances to the chart origin
    std::vector &lt; double > distances;
    // The chart coordinates as a size columns matrix of size-1 rows
    cv::Mat coordinates;
  };
  std::vector &lt; Chart > charts;
  struct Transition {
	   // The charts indexes of this transition map
	   std::pair &lt; unsigned int, unsigned int > charts;
	   // The points indexes that are in the intersection
	   std::vector &lt; unsigned int > indexes;
	   // The transition map, of the form X_q = matrix * X_p + vector
	   cv::Mat matrix, vector;
    // Transform properties
    unsigned int affine_matrix_rank, affine_isometric_rank, rigid_matrix_rank;
  };
  std::vector &lt; std::vector &lt; Transition >> transitions;
};
</code></pre>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Atlas</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".asJSON"><span class="type-signature type-signature-static">(static) </span>asJSON<span class="signature">()</span><span class="type-signature"> &rarr; {JSON}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the vector embedding and affine embedding atlas as a wJSON data structure.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The embedding atlas as a wJSON data structure.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".asImage"><span class="type-signature type-signature-static">(static) </span>asImage<span class="signature">()</span><span class="type-signature"> &rarr; {Mat}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the vector embedding drawn in a 2D image.
The <code>cv::imwrite(&quot;filename.png&quot;, embedding.asImage());</code> construct allows to save the image.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A BGR <code>CV_8UC3</code> <code>cv::Mat</code> image with the drawn data structure.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Mat</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>